-- Insert new EC2 APP
SET @current_app_type = 6;
SET @short_name = 'pandorafms.aws.ec2';
SET @name = 'Amazon&#x20;EC2';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;EC2&#x20;instances';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_ec2');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_ec2');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileEC2_&#039;');

-- Migrate current EC2 tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleIP_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_ip')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentaclePort_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_port')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleExtraOpt_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_opts')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.aws', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `trecon_task`.`type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_useProxy_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_proxyUrl_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sslCheck_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 4;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 5;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 6;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 7;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 8;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 9;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 10;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 11;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 12;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgent_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgentName_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_globalTotalCost_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2InstanceSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2CpuPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2IopsPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2DiskPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2NetworkPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2StorageSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2ElasticAddressesSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_globalCostInterval_', 'custom', 604800, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'global_cost_region';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_globalCostRegion_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'ec2_instance';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_ec2Instance_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'ec2_zones';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_ec2Zones_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2ZonesInstance_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileEC2_', 'custom', 'interval=__taskInterval__&#x0d;&#x0a;agents_group_name=__taskGroup__&#x0d;&#x0a;storage=_ec2StorageSummary_&#x0d;&#x0a;elastic_ip_address=_ec2ElasticAddressesSummary_&#x0d;&#x0a;advance_monitoring=_ec2InstanceSummary_&#x0d;&#x0a;cpu_summary=_ec2CpuPerfSummary_&#x0d;&#x0a;iops_summary=_ec2IopsPerfSummary_&#x0d;&#x0a;disk_summary=_ec2DiskPerfSummary_&#x0d;&#x0a;network_summary=_ec2NetworkPerfSummary_&#x0d;&#x0a;total_cost=_globalTotalCost_&#x0d;&#x0a;interval_cost=_globalCostInterval_&#x0d;&#x0a;aws_instances=_ec2Instance_&#x0d;&#x0a;aws_regions=_ec2Zones_&#x0d;&#x0a;cost_regions=_globalCostRegion_&#x0d;&#x0a;creds_b64=_credentials_&#x0d;&#x0a;temporal=__temp__&#x0d;&#x0a;transfer_mode=tentacle&#x0d;&#x0a;tentacle_ip=_tentacleIP_&#x0d;&#x0a;tentacle_port=_tentaclePort_&#x0d;&#x0a;tentacle_opts=_tentacleExtraOpt_&#x0d;&#x0a;threads=_threads_&#x0d;&#x0a;stats_agent=_statsAgent_&#x0d;&#x0a;stats_agent=_statsAgentName_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Delete NULL macros
DELETE FROM `tdiscovery_apps_tasks_macros` WHERE `macro` = '';

-- Migrate current EC2 tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;