START TRANSACTION;

-- Remove column id_usuario_destino from tmensajes --
SET @exist = (SELECT count(*) FROM information_schema.columns WHERE TABLE_NAME='tmensajes' AND COLUMN_NAME='id_usuario_destino' AND table_schema = DATABASE());
SET @sqlstmt = IF (@exist>0, 'ALTER TABLE `tmensajes` DROP COLUMN `id_usuario_destino`', 'SELECT ""');
prepare stmt from @sqlstmt;
execute stmt;

DROP TABLE IF EXISTS tskin;
DROP TABLE IF EXISTS tnetwork_matrix;

ALTER TABLE tfavmenu_user CONVERT TO CHARACTER SET UTF8MB4;
ALTER TABLE tfiles_repo CONVERT TO CHARACTER SET UTF8MB4;
ALTER TABLE tfiles_repo_group CONVERT TO CHARACTER SET UTF8MB4;

ALTER TABLE `tusuario`
ADD COLUMN `stop_lts_modal` TINYINT NOT NULL DEFAULT 0 AFTER `session_max_time_expire`;

ALTER TABLE `tlayout_template` ADD COLUMN `create_from` INT UNSIGNED NOT NULL DEFAULT 0;

DELETE FROM `tlanguage` WHERE `id_language` = 'zh_CN';
UPDATE `tusuario` SET `language` = 'default' WHERE `language` = 'zh_CN';
UPDATE `tconfig` SET `value` = 'en_GB' WHERE `token` = 'language' AND `value` = 'zh_CN';
UPDATE `tconfig` SET `value` = 'Andromeda' WHERE `token` = 'lts_name';

SET @id_token_last_compact_offset = NULL;
SET @token_name_last_compact_offset = 'last_compact_offset';
SELECT @id_token_last_compact_offset := `id_config` FROM `tconfig` WHERE `token` = @token_name_last_compact_offset ORDER BY `id_config` DESC LIMIT 1;
DELETE FROM `tconfig` WHERE `token` = @token_name_last_compact_offset AND `id_config` != @id_token_last_compact_offset;

-- START MIGRATION MSSQL --
SET @current_app_type = 12;
SET @short_name = 'pandorafms.mssql';
SET @name = 'Microsoft&#x20;SQL&#x20;Server';
SET @section = 'app';
SET @description = 'Monitor&#x20;Microsoft&#x20;SQL&#x20;Server&#x20;databases';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_mssql');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--target_databases&#x20;&#039;_tempfileTargetDatabases_&#039;&#x20;--target_agents&#x20;&#039;_tempfileTargetAgents_&#039;&#x20;--custom_queries&#x20;&#039;_tempfileCustomQueries_&#039;');

-- Migrate current MSSQL tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbstrings_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbstrings')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbuser_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbuser')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbpass_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbpass')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_engineAgent_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.engine_agent')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixModuleName_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_module_name')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkUptime_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_uptime')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_queryStats_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.query_stats')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkConnections_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_connections')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_executeCustomQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.execute_custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;user&#x20;=&#x20;_dbuser_&#x0d;&#x0a;password&#x20;=&#x20;_dbpass_&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;modules_prefix&#x20;=&#x20;_prefixModuleName_&#x0d;&#x0a;execute_custom_queries&#x20;=&#x20;_executeCustomQueries_&#x0d;&#x0a;analyze_connections&#x20;=&#x20;_checkConnections_&#x0d;&#x0a;engine_uptime&#x20;=&#x20;_checkUptime_&#x0d;&#x0a;query_stats&#x20;=&#x20;_queryStats_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetDatabases_', 'custom', '_dbstrings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetAgents_', 'custom', '_engineAgent_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomQueries_', 'custom', '_customQueries_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current MSSQL tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;

-- END MIGRATION MSSQL --

-- START MIGRATION MYSQL --

-- Insert new MySQL APP
SET @current_app_type = 4;
SET @short_name = 'pandorafms.mysql';
SET @name = 'MySQL';
SET @section = 'app';
SET @description = 'Monitor&#x20;MySQL&#x20;databases';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_mysql');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--target_databases&#x20;&#039;_tempfileTargetDatabases_&#039;&#x20;--target_agents&#x20;&#039;_tempfileTargetAgents_&#039;&#x20;--custom_queries&#x20;&#039;_tempfileCustomQueries_&#039;');

-- Migrate current MySQL tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    WITH RECURSIVE `cte` AS (
        SELECT
            `id_rt`,
            REPLACE(JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbport')), '&#x20;', '') AS `port`,
            1 AS `pos`,
            SUBSTRING_INDEX(
                REPLACE(JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbhost')), '&#x20;', ''),
                ',', 1
            ) AS `host`,
            SUBSTRING(
                REPLACE(JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbhost')), '&#x20;', ''),
                LENGTH(SUBSTRING_INDEX(
                    REPLACE(JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbhost')), '&#x20;', ''),
                    ',', 1
                )) + 2
            ) AS `remaining`
        FROM `trecon_task` WHERE `type` = @current_app_type
        UNION ALL
        SELECT `id_rt`, `port`, `pos` + 1, SUBSTRING_INDEX(`remaining`, ',', 1) AS `host`, SUBSTRING(`remaining`, LENGTH(SUBSTRING_INDEX(`remaining`, ',', 1)) + 2)
        FROM `cte`
        WHERE `remaining` != ''
    )
    SELECT `id_rt`, '_dbstrings_', 'custom', GROUP_CONCAT(CONCAT(`host`, ':', `port`) SEPARATOR ','), 0
    FROM `cte`
    GROUP BY `id_rt`
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbuser_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbuser')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbpass_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbpass')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_engineAgent_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.engine_agent')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixModuleName_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_module_name')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_scanDatabases_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.scan_databases')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_agentPerDatabase_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.agent_per_database')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixAgent_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_agent')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkUptime_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_uptime')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_queryStats_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.query_stats')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkConnections_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_connections')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkInnodb_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_innodb')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkCache_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_cache')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_executeCustomQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.execute_custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;user&#x20;=&#x20;_dbuser_&#x0d;&#x0a;password&#x20;=&#x20;_dbpass_&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;modules_prefix&#x20;=&#x20;_prefixModuleName_&#x0d;&#x0a;execute_custom_queries&#x20;=&#x20;_executeCustomQueries_&#x0d;&#x0a;analyze_connections&#x20;=&#x20;_checkConnections_&#x0d;&#x0a;scan_databases&#x20;=&#x20;_scanDatabases_&#x0d;&#x0a;agent_per_database&#x20;=&#x20;_agentPerDatabase_&#x0d;&#x0a;db_agent_prefix&#x20;=&#x20;_prefixAgent_&#x0d;&#x0a;innodb_stats&#x20;=&#x20;_checkInnodb_&#x0d;&#x0a;engine_uptime&#x20;=&#x20;_checkUptime_&#x0d;&#x0a;query_stats&#x20;=&#x20;_queryStats_&#x0d;&#x0a;cache_stats&#x20;=&#x20;_checkCache_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetDatabases_', 'custom', '_dbstrings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetAgents_', 'custom', '_engineAgent_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomQueries_', 'custom', '_customQueries_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current MySQL tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;

-- END MIGRATION MYSQL --


-- START MIGRATION ORACLE --

-- Insert new Oracle APP
SET @current_app_type = 5;
SET @short_name = 'pandorafms.oracle';
SET @name = 'Oracle';
SET @section = 'app';
SET @description = 'Monitor&#x20;Oracle&#x20;databases';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_oracle');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--target_databases&#x20;&#039;_tempfileTargetDatabases_&#039;&#x20;--target_agents&#x20;&#039;_tempfileTargetAgents_&#039;&#x20;--custom_queries&#x20;&#039;_tempfileCustomQueries_&#039;');

-- Migrate current Oracle tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbstrings_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbstrings')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbuser_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbuser')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbpass_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbpass')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_engineAgent_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.engine_agent')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixModuleName_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_module_name')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkUptime_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_uptime')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_queryStats_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.query_stats')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkConnections_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_connections')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkFragmentation_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_fragmentation')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkTablespaces_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_tablespaces')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkCache_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_cache')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_executeCustomQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.execute_custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;user&#x20;=&#x20;_dbuser_&#x0d;&#x0a;password&#x20;=&#x20;_dbpass_&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;modules_prefix&#x20;=&#x20;_prefixModuleName_&#x0d;&#x0a;execute_custom_queries&#x20;=&#x20;_executeCustomQueries_&#x0d;&#x0a;analyze_connections&#x20;=&#x20;_checkConnections_&#x0d;&#x0a;engine_uptime&#x20;=&#x20;_checkUptime_&#x0d;&#x0a;query_stats&#x20;=&#x20;_queryStats_&#x0d;&#x0a;cache_stats&#x20;=&#x20;_checkCache_&#x0d;&#x0a;fragmentation_ratio&#x20;=&#x20;_checkFragmentation_&#x0d;&#x0a;check_tablescpaces&#x20;=&#x20;_checkTablespaces_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetDatabases_', 'custom', '_dbstrings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetAgents_', 'custom', '_engineAgent_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomQueries_', 'custom', '_customQueries_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current Oracle tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;

-- END MIGRATION ORACLE --


-- START MIGRATION VMWARE --
-- Insert new VMware APP
SET @current_app_type = 3;
SET @short_name = 'pandorafms.vmware';
SET @name = 'VMware';
SET @section = 'app';
SET @description = 'Monitor&#x20;ESXi&#x20;hosts,&#x20;datastores&#x20;and&#x20;VMs&#x20;from&#x20;a&#x20;specific&#x20;datacenter';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_vmware');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/vmware_instances');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;&#039;_tempfileVMware_&#039;&#x20;--as_discovery_plugin&#x20;1');

-- Migrate current VMware tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleIP_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_ip')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentaclePort_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_port')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleExtraOpt_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_opts')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 2;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_server_', 'custom', SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 8), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 3;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_datacenter_', 'custom', SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 12), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 4;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_user_', 'custom', SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 6;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_useEncryptedPassword_', 'custom', SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 24), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 7;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 8;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 9;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 10;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 11;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 12;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 13;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 14;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 15;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        '_pass_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        '_threads_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        '_reconInterval_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        '_virtualNetworkMonitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        '_retrySend_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        '_eventMode_',
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        '_extraSettings_',
        NULL
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "pass",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 6),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "threads",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 9),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "recon_interval",
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), 16),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "virtual_network_monitoring",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "retry_send",
        "1",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1) = "event_mode",
        "1",
    IF(
        SUBSTRING(SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position), "\n", -1), " ", 1), 1, 20) = "#__EXTRA__SETTINGS__",
        SUBSTRING(SUBSTRING_INDEX(REPLACE(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "\n", @position - 1), ""), "Reject", 1), 22),
        "0"
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 2;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        '_scanDatastore_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        '_scanDatacenter_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        '_scanESX_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        '_scanVM_',
        NULL
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        "0",
        ""
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 3;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        '_scanDatastore_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        '_scanDatacenter_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        '_scanESX_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        '_scanVM_',
        NULL
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        "0",
        ""
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 4;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        '_scanDatastore_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        '_scanDatacenter_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        '_scanESX_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        '_scanVM_',
        NULL
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        "0",
        ""
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 5;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        '_scanDatastore_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        '_scanDatacenter_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        '_scanESX_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        '_scanVM_',
        NULL
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datastore",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_datacenter",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_esx",
        "0",
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "Reject", -1), "\n", @position), "\n", -1) = "all_vm",
        "0",
        ""
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 5, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_virtualNetworkMonitoring_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_retrySend_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_eventMode_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_extraSettings_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_scanDatastore_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_scanDatacenter_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_scanESX_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_scanVM_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_monitorExclusiveAgents_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_exclusiveAgents_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_exclusiveESXi_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_exclusiveDatastores_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_exclusiveVMs_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileVMware_', 'custom', 'Configuration&#x0d;&#x0a;server _server_&#x0d;&#x0a;datacenter _datacenter_&#x0d;&#x0a;user _user_&#x0d;&#x0a;group __taskGroup__&#x0d;&#x0a;use_encrypted_password _useEncryptedPassword_&#x0d;&#x0a;interval __taskInterval__&#x0d;&#x0a;pass _pass_&#x0d;&#x0a;threads _threads_&#x0d;&#x0a;event_mode _eventMode_&#x0d;&#x0a;retry_send _retrySend_&#x0d;&#x0a;virtual_network_monitoring _virtualNetworkMonitoring_&#x0d;&#x0a;recon_interval _reconInterval_&#x0d;&#x0a;&#x0d;&#x0a;scan_datastore _scanDatastore_&#x0d;&#x0a;scan_datacenter _scanDatacenter_&#x0d;&#x0a;scan_esx _scanESX_&#x0d;&#x0a;scan_vm _scanVM_&#x0d;&#x0a;&#x0d;&#x0a;logfile __temp__/tmp_discovery.__taskMD5__.log&#x0d;&#x0a;entities_list __temp__/tmp_discovery.__taskMD5__.entities&#x0d;&#x0a;event_pointer_file __temp__/tmp_discovery.__taskMD5__.events&#x0d;&#x0a;temporal __temp__&#x0d;&#x0a;transfer_mode tentacle&#x0d;&#x0a;tentacle_ip _tentacleIP_&#x0d;&#x0a;tentacle_port _tentaclePort_&#x0d;&#x0a;tentacle_opts _tentacleExtraOpt_&#x0d;&#x0a;local_folder __incomingDir__&#x0d;&#x0a;pandora_url __consoleAPIURL__&#x0d;&#x0a;api_pass __consoleAPIPass__&#x0d;&#x0a;api_user __consoleUser__&#x0d;&#x0a;apiuser_pass __consolePass__&#x0d;&#x0a;&#x0d;&#x0a;_extraSettings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Delete NULL macros
DELETE FROM `tdiscovery_apps_tasks_macros` WHERE `macro` = '';

-- Migrate current VMware tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;
-- END MIGRATION WMWARE --

-- START MIGRATION SAP --
-- Insert new SAP APP
SET @current_app_type = 10;
SET @short_name = 'pandorafms.sap.deset';
SET @name = 'SAP&#x20;R3&#x20;-&#x20;Deset';
SET @section = 'app';
SET @description = 'Monitor&#x20;SAP&#x20;R3&#x20;environments';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_sap_deset');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_java_', 'bin/lib/jre/bin/java');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--custom_modules&#x20;&#039;_tempfileCustomModules_&#039;');

-- Migrate current SAP tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_server_', 'custom', `subnet`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sapClient_', 'custom', `field3`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sapSystem_', 'custom', `field2`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sapLicense_', 'custom', `field4`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.sap', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customModules_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_targetAgent_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_customModulesDefinition_',
    'custom',
    JSON_UNQUOTE(
      JSON_EXTRACT(
        REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
            '"160"',
            '""'
            ),
            '"109"',
            '""'
            ),
            '"111"',
            '""'
            ),
            '"113"',
            '""'
            ),
            '"121"',
            '""'
            ),
            '"104"',
            '""'
            ),
            '"105"',
            '""'
            ),
            '"150"',
            '""'
            ),
            '"151"',
            '""'
            ),
            '"102"',
            '""'
            ),
            '"103"',
            '""'
            ),
            '"192"',
            '""'
            ),
            '"195"',
            '""'
            ),
            '"116"',
            '""'
            ),
            '","',
            ""
        ),
        '$[0]'
      )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = -1;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -2;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -3;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -4;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -5;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -6;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -7;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -8;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -9;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -10;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -11;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -12;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -13;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -14;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task`
    SET
    `tdiscovery_apps_tasks_macros`.`value` = REPLACE(REPLACE(REPLACE(`value`, '"", ', ''), '""', ''), ', ]', ']')
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `trecon_task`.`id_rt` AND
    `trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task`
    SET
    `tdiscovery_apps_tasks_macros`.`value` = (
        SELECT `tconfig`.`value` FROM `tconfig` WHERE `tconfig`.`token` = 'sap_license'
    )
    WHERE
    `tdiscovery_apps_tasks_macros`.`id_task` = `trecon_task`.`id_rt` AND
    `trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_sapLicense_' AND
    `tdiscovery_apps_tasks_macros`.`value` = ''
;

UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task`
    SET
    `tdiscovery_apps_tasks_macros`.`value` = 'trial'
    WHERE
    `tdiscovery_apps_tasks_macros`.`id_task` = `trecon_task`.`id_rt` AND
    `trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_sapLicense_' AND
    `tdiscovery_apps_tasks_macros`.`value` = ''
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;server&#x20;=&#x20;_server_&#x0d;&#x0a;client&#x20;=&#x20;_sapClient_&#x0d;&#x0a;system&#x20;=&#x20;_sapSystem_&#x0d;&#x0a;license&#x20;=&#x20;_sapLicense_&#x0d;&#x0a;credentials&#x20;=&#x20;_credentials_&#x0d;&#x0a;agent&#x20;=&#x20;_targetAgent_&#x0d;&#x0a;modules&#x20;=&#x20;_customModules_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomModules_', 'custom', '_customModulesDefinition_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current SAP tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;
-- END MIGRATION SAP --

-- START MIGRATION DB2 --
-- Insert new DB2 APP
SET @current_app_type = 11;
SET @short_name = 'pandorafms.db2';
SET @name = 'DB2';
SET @section = 'app';
SET @description = 'Monitor&#x20;DB2&#x20;databases';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_db2');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--target_databases&#x20;&#039;_tempfileTargetDatabases_&#039;&#x20;--target_agents&#x20;&#039;_tempfileTargetAgents_&#039;&#x20;--custom_queries&#x20;&#039;_tempfileCustomQueries_&#039;');

-- Migrate current DB2 tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbstrings_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbstrings')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbuser_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbuser')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbpass_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbpass')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_engineAgent_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.engine_agent')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixModuleName_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_module_name')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkDbSummary_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_db_summary')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkTransactionalLogUtilization_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_transactional_log_utilization')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkConnections_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_connections')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkDbSize_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_db_size')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkCache_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_cache')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_executeCustomQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.execute_custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;user&#x20;=&#x20;_dbuser_&#x0d;&#x0a;password&#x20;=&#x20;_dbpass_&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;modules_prefix&#x20;=&#x20;_prefixModuleName_&#x0d;&#x0a;execute_custom_queries&#x20;=&#x20;_executeCustomQueries_&#x0d;&#x0a;analyze_connections&#x20;=&#x20;_checkConnections_&#x0d;&#x0a;cache_stats&#x20;=&#x20;_checkCache_&#x0d;&#x0a;database_summary&#x20;=&#x20;_checkDbSummary_&#x0d;&#x0a;transactional_log&#x20;=&#x20;_checkTransactionalLogUtilization_&#x0d;&#x0a;db_size&#x20;=&#x20;_checkDbSize_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetDatabases_', 'custom', '_dbstrings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetAgents_', 'custom', '_engineAgent_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomQueries_', 'custom', '_customQueries_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current DB2 tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;
-- END MIGRATION DB2 --

-- START MIGRATION AWS EC2 --
-- Insert new EC2 APP
SET @current_app_type = 6;
SET @short_name = 'pandorafms.aws.ec2';
SET @name = 'Amazon&#x20;EC2';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;EC2&#x20;instances';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_ec2');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_ec2');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileEC2_&#039;');

-- Migrate current EC2 tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleIP_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_ip')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentaclePort_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_port')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleExtraOpt_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_opts')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.aws', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `trecon_task`.`type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_useProxy_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_proxyUrl_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sslCheck_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 4;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 5;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 6;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 7;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 8;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 9;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 10;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 11;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 12;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        '_globalTotalCost_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_ec2InstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_ec2CpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_ec2IopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_ec2DiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_ec2NetworkPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        '_ec2StorageSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        '_ec2ElasticAddressesSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        '_globalCostInterval_',
        NULL
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_total_cost',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_storage_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_elastic_addresses_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", 1) = 'global_cost_interval',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ), IF( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", 1 ) != SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), REPLACE( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONCAT( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ), IF( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", 1 ) != SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), REPLACE( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), CONCAT( SUBSTRING_INDEX( SUBSTRING_INDEX( CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), "global_cost_region ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_instance ", -1 ), "\n",1 ), "\n" ), "" ), "" ) ), "ec2_zones ", -1 ), "\n",1 ), "\n" ), "" ), "" ) )
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgent_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgentName_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_globalTotalCost_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2InstanceSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2CpuPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2IopsPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2DiskPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2NetworkPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2StorageSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2ElasticAddressesSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_globalCostInterval_', 'custom', 604800, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'global_cost_region';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_globalCostRegion_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'ec2_instance';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_ec2Instance_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'ec2_zones';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_ec2Zones_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_ec2ZonesInstance_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileEC2_', 'custom', 'interval=__taskInterval__&#x0d;&#x0a;agents_group_name=__taskGroup__&#x0d;&#x0a;storage=_ec2StorageSummary_&#x0d;&#x0a;elastic_ip_address=_ec2ElasticAddressesSummary_&#x0d;&#x0a;advance_monitoring=_ec2InstanceSummary_&#x0d;&#x0a;cpu_summary=_ec2CpuPerfSummary_&#x0d;&#x0a;iops_summary=_ec2IopsPerfSummary_&#x0d;&#x0a;disk_summary=_ec2DiskPerfSummary_&#x0d;&#x0a;network_summary=_ec2NetworkPerfSummary_&#x0d;&#x0a;total_cost=_globalTotalCost_&#x0d;&#x0a;interval_cost=_globalCostInterval_&#x0d;&#x0a;aws_instances=_ec2Instance_&#x0d;&#x0a;aws_regions=_ec2Zones_&#x0d;&#x0a;cost_regions=_globalCostRegion_&#x0d;&#x0a;creds_b64=_credentials_&#x0d;&#x0a;temporal=__temp__&#x0d;&#x0a;transfer_mode=tentacle&#x0d;&#x0a;tentacle_ip=_tentacleIP_&#x0d;&#x0a;tentacle_port=_tentaclePort_&#x0d;&#x0a;tentacle_opts=_tentacleExtraOpt_&#x0d;&#x0a;threads=_threads_&#x0d;&#x0a;stats_agent=_statsAgent_&#x0d;&#x0a;stats_agent=_statsAgentName_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Delete NULL macros
DELETE FROM `tdiscovery_apps_tasks_macros` WHERE `macro` = '';

-- Migrate current EC2 tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;
-- END MIGRATION AWS EC2 --


-- START MIGRATION AWS RDS --
-- Insert new RDS APP
SET @current_app_type = 7;
SET @short_name = 'pandorafms.aws.rds';
SET @name = 'Amazon&#x20;RDS';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;RDS&#x20;instances';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_rds');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_rds');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileRDS_&#039;');

-- Insert new MySQL APP
SET @short_name = 'pandorafms.mysql';
SET @name = 'MySQL';
SET @section = 'app';
SET @description = 'Monitor&#x20;MySQL&#x20;databases';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app_mysql := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_mysql');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES ('', @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--target_databases&#x20;&#039;_tempfileTargetDatabases_&#039;&#x20;--target_agents&#x20;&#039;_tempfileTargetAgents_&#039;&#x20;--custom_queries&#x20;&#039;_tempfileCustomQueries_&#039;');

-- Insert new Oracle APP
SET @short_name = 'pandorafms.oracle';
SET @name = 'Oracle';
SET @section = 'app';
SET @description = 'Monitor&#x20;Oracle&#x20;databases';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app_oracle := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_oracle');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES ('', @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--target_databases&#x20;&#039;_tempfileTargetDatabases_&#039;&#x20;--target_agents&#x20;&#039;_tempfileTargetAgents_&#039;&#x20;--custom_queries&#x20;&#039;_tempfileCustomQueries_&#039;');

-- Migrate current RDS tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleIP_', 'custom', '127.0.0.1', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentaclePort_', 'custom', '41121', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleExtraOpt_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.aws', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `trecon_task`.`type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_useProxy_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_proxyUrl_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sslCheck_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsInstance_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbtargets')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsZones_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsZonesInstance_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsInstanceSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsCpuPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsIopsPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsDiskPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_rdsNetworkPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileRDS_', 'custom', 'interval=__taskInterval__&#x0d;&#x0a;agents_group_name=__taskGroup__&#x0d;&#x0a;advance_monitoring=_rdsInstanceSummary_&#x0d;&#x0a;cpu_summary=_rdsCpuPerfSummary_&#x0d;&#x0a;iops_summary=_rdsIopsPerfSummary_&#x0d;&#x0a;disk_summary=_rdsDiskPerfSummary_&#x0d;&#x0a;network_summary=_rdsNetworkPerfSummary_&#x0d;&#x0a;aws_instances=_rdsInstance_&#x0d;&#x0a;aws_regions=_rdsZones_&#x0d;&#x0a;creds_b64=_credentials_&#x0d;&#x0a;temporal=__temp__&#x0d;&#x0a;transfer_mode=tentacle&#x0d;&#x0a;tentacle_ip=_tentacleIP_&#x0d;&#x0a;tentacle_port=_tentaclePort_&#x0d;&#x0a;tentacle_opts=_tentacleExtraOpt_&#x0d;&#x0a;threads=_threads_&#x0d;&#x0a;stats_agent=_statsAgent_&#x0d;&#x0a;stats_agent_name=_statsAgentName_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgent_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgentName_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current RDS tasks to MySQL tasks
INSERT IGNORE INTO `trecon_task`
    (
        `id_rt`,
        `name`,
        `description`,
        `id_group`,
        `utimestamp`,
        `status`,
        `interval_sweep`,
        `id_recon_server`,
        `disabled`,
        `summary`,
        `type`,
        `id_app`,
        `setup_complete`,
        `field1`
    )
    SELECT
        '',
        CONCAT('MySQL&#x20;-&#x20;', `name`),
        CONCAT('Migrated&#x20;from&#x20;-&#x20;', `name`),
        `id_group`,
        `utimestamp`,
        `status`,
        `interval_sweep`,
        `id_recon_server`,
        `disabled`,
        `summary`,
        `type`,
        @id_app_mysql,
        0,
        `field1`
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbengine')) = 'mysql'
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbstrings_', 'custom', REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbtargets')),'","',','),'["',''),'"]',''),'[',''),']',''), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbuser_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbuser')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbpass_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbpass')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', '1', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_engineAgent_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixModuleName_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_module_name')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_scanDatabases_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.scan_databases')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_agentPerDatabase_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.agent_per_database')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixAgent_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_agent')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkUptime_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_uptime')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_queryStats_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.query_stats')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkConnections_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_connections')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkInnodb_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_innodb')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkCache_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_cache')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_executeCustomQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.execute_custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;user&#x20;=&#x20;_dbuser_&#x0d;&#x0a;password&#x20;=&#x20;_dbpass_&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;modules_prefix&#x20;=&#x20;_prefixModuleName_&#x0d;&#x0a;execute_custom_queries&#x20;=&#x20;_executeCustomQueries_&#x0d;&#x0a;analyze_connections&#x20;=&#x20;_checkConnections_&#x0d;&#x0a;scan_databases&#x20;=&#x20;_scanDatabases_&#x0d;&#x0a;agent_per_database&#x20;=&#x20;_agentPerDatabase_&#x0d;&#x0a;db_agent_prefix&#x20;=&#x20;_prefixAgent_&#x0d;&#x0a;innodb_stats&#x20;=&#x20;_checkInnodb_&#x0d;&#x0a;engine_uptime&#x20;=&#x20;_checkUptime_&#x0d;&#x0a;query_stats&#x20;=&#x20;_queryStats_&#x0d;&#x0a;cache_stats&#x20;=&#x20;_checkCache_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetDatabases_', 'custom', '_dbstrings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetAgents_', 'custom', '_engineAgent_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomQueries_', 'custom', '_customQueries_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

-- Migrate current RDS tasks to Oracle tasks
INSERT IGNORE INTO `trecon_task`
    (
        `id_rt`,
        `name`,
        `description`,
        `id_group`,
        `utimestamp`,
        `status`,
        `interval_sweep`,
        `id_recon_server`,
        `disabled`,
        `summary`,
        `type`,
        `id_app`,
        `setup_complete`,
        `field1`
    )
    SELECT
        '',
        CONCAT('Oracle&#x20;-&#x20;', `name`),
        CONCAT('Migrated&#x20;from&#x20;-&#x20;', `name`),
        `id_group`,
        `utimestamp`,
        `status`,
        `interval_sweep`,
        `id_recon_server`,
        `disabled`,
        `summary`,
        `type`,
        @id_app_oracle,
        0,
        `field1`
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbengine')) = 'oracle'
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbstrings_', 'custom', REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbtargets')),'","',','),'["',''),'"]',''),'[',''),']',''), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbuser_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbuser')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_dbpass_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.dbpass')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', '1', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_engineAgent_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_prefixModuleName_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.prefix_module_name')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkUptime_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_uptime')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_queryStats_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.query_stats')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkConnections_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_connections')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkFragmentation_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_fragmentation')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkTablespaces_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_tablespaces')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_checkCache_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.check_cache')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_executeCustomQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.execute_custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customQueries_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(CONVERT(FROM_BASE64(`field1`) USING UTF8MB4), '$.custom_queries')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;user&#x20;=&#x20;_dbuser_&#x0d;&#x0a;password&#x20;=&#x20;_dbpass_&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;modules_prefix&#x20;=&#x20;_prefixModuleName_&#x0d;&#x0a;execute_custom_queries&#x20;=&#x20;_executeCustomQueries_&#x0d;&#x0a;analyze_connections&#x20;=&#x20;_checkConnections_&#x0d;&#x0a;engine_uptime&#x20;=&#x20;_checkUptime_&#x0d;&#x0a;query_stats&#x20;=&#x20;_queryStats_&#x0d;&#x0a;cache_stats&#x20;=&#x20;_checkCache_&#x0d;&#x0a;fragmentation_ratio&#x20;=&#x20;_checkFragmentation_&#x0d;&#x0a;check_tablescpaces&#x20;=&#x20;_checkTablespaces_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetDatabases_', 'custom', '_dbstrings_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileTargetAgents_', 'custom', '_engineAgent_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomQueries_', 'custom', '_customQueries_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

-- Migrate current RDS tasks
UPDATE `trecon_task`
    SET
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type AND `id_app` = @id_app_mysql
;

UPDATE `trecon_task`
    SET
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type AND `id_app` = @id_app_oracle
;

UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type AND `id_app` IS NULL
;
-- END MIGRATION AWS RDS --

-- START MIGRATION AWS S3 --

-- Insert new S3 APP
SET @current_app_type = 14;
SET @short_name = 'pandorafms.aws.s3';
SET @name = 'Amazon&#x20;S3';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;S3&#x20;buckets';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_s3');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_s3');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileS3_&#039;');

-- Migrate current S3 tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleIP_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_ip')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentaclePort_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_port')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleExtraOpt_', 'custom', JSON_UNQUOTE(JSON_EXTRACT(`field2`, '$.tentacle_opts')), 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.aws', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `trecon_task`.`type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_useProxy_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_proxyUrl_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sslCheck_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 3;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_monitoring',
        '_s3Monitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_size',
        '_s3Size_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_items',
        '_s3Items_',
        NULL
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_monitoring',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_size',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_items',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 4;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_monitoring',
        '_s3Monitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_size',
        '_s3Size_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_items',
        '_s3Items_',
        NULL
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_monitoring',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_size',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_items',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 5;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_monitoring',
        '_s3Monitoring_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_size',
        '_s3Size_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_items',
        '_s3Items_',
        NULL
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_monitoring',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_size',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 's3_items',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"s3_zone ",-1),"\n",1),"\n"),"")),"s3_bucket ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgent_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgentName_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_s3Monitoring_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_s3Size_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_s3Items_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 's3_bucket';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_s3Bucket_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 's3_zone';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_s3Zone_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileS3_', 'custom', 'interval=__taskInterval__&#x0d;&#x0a;agents_group_name=__taskGroup__&#x0d;&#x0a;aws_regions=_s3Zone_&#x0d;&#x0a;aws_buckets=_s3Bucket_&#x0d;&#x0a;s3_monitoring=_s3Monitoring_&#x0d;&#x0a;size_monitoring=_s3Size_&#x0d;&#x0a;items_monitoring=_s3Items_&#x0d;&#x0a;creds_b64=_credentials_&#x0d;&#x0a;temporal=__temp__&#x0d;&#x0a;transfer_mode=tentacle&#x0d;&#x0a;tentacle_ip=_tentacleIP_&#x0d;&#x0a;tentacle_port=_tentaclePort_&#x0d;&#x0a;tentacle_opts=_tentacleExtraOpt_&#x0d;&#x0a;threads=_threads_&#x0d;&#x0a;stats_agent=_statsAgent_&#x0d;&#x0a;stats_agent_name=_statsAgentName_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Delete NULL macros
DELETE FROM `tdiscovery_apps_tasks_macros` WHERE `macro` = '';

-- Migrate current S3 tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;
-- END MIGRATION AWS S3 --

-- START MIGRATION GCP --
-- Insert new Google APP
SET @current_app_type = 13;
SET @short_name = 'pandorafms.gcp.ce';
SET @name = 'Google&#x20;Cloud&#x20;Compute&#x20;Engine';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;Google&#x20;Cloud&#x20;Platform&#x20;Compute&#x20;Engine&#x20;VMs';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_gcp_ce');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/google_instances');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileGoogleCE_&#039;');

-- Migrate current Google tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleIP_', 'custom', '127.0.0.1', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentaclePort_', 'custom', '41121', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tentacleExtraOpt_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.gcp', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `trecon_task`.`type` = @current_app_type
;

SET @position = 4;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_googleCEInstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_googleCECpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_googleCEIopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_googleCEDiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_googleCENetworkPerfSummary_',
        NULL
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 5;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_googleCEInstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_googleCECpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_googleCEIopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_googleCEDiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_googleCENetworkPerfSummary_',
        NULL
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 6;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_googleCEInstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_googleCECpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_googleCEIopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_googleCEDiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_googleCENetworkPerfSummary_',
        NULL
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 7;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_googleCEInstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_googleCECpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_googleCEIopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_googleCEDiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_googleCENetworkPerfSummary_',
        NULL
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = 8;
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        '_googleCEInstanceSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        '_googleCECpuPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        '_googleCEIopsPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        '_googleCEDiskPerfSummary_',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        '_googleCENetworkPerfSummary_',
        NULL
    )
    )
    )
    )
    ),
    'custom',
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_instance_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_cpu_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_iops_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_disk_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
    IF(
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", 1) = 'ec2_network_perf_summary',
        SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(
            CONCAT(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",1),REPLACE(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONCAT(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",1),REPLACE(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),CONCAT(SUBSTRING_INDEX(SUBSTRING_INDEX(CONVERT(FROM_BASE64(field1) USING UTF8MB4),"ec2_zones ",-1),"\n",1),"\n"),"")),"ec2_instance ",-1),"\n",1),"\n"),""))
        , "\n", @position), "\n", -1), " ", -1),
        "0"
    )
    )
    )
    )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgent_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_statsAgentName_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_googleCEInstanceSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_googleCECpuPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_googleCEIopsPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_googleCEDiskPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_googleCENetworkPerfSummary_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'ec2_instance';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_googleCEInstance_',
    'custom', 
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @param = 'ec2_zones';
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_googleCEZones_',
    'custom',
    REPLACE(
        REPLACE(
            CONCAT(
                '["',
                REPLACE(
                    REPLACE(
                        REPLACE(
                            REPLACE(
                                CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                SUBSTRING_INDEX(
                                    CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                    CONCAT(@param, " "), 1
                                ),
                                ""
                            ),
                            REPLACE(
                                SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ),
                                SUBSTRING_INDEX(SUBSTRING_INDEX(
                                    REPLACE(
                                        CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                        SUBSTRING_INDEX(
                                            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
                                            CONCAT(@param, " "), 1
                                        ),
                                        ""
                                    ),
                                    CONCAT(@param, " "), -1
                                ), "\n", 1),
                                ""
                            ),
                            "\n"
                        ),
                        CONCAT(@param, " "),
                        ""
                    ),
                    "\n",
                    '","'
                ),
                '"]'
            ),
            ',""]',
            ']'
        ),
        '[""]',
        '[]'
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_googleCEZonesInstance_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_useProxy_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_proxyUrl_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sslCheck_', 'custom', 0, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileGoogleCE_', 'custom', 'agents_group_name=__taskGroup__&#x0d;&#x0a;interval=__taskInterval__&#x0d;&#x0a;threads=_threads_&#x0d;&#x0a;temporal=__temp__&#x0d;&#x0a;transfer_mode=tentacle&#x0d;&#x0a;tentacle_ip=_tentacleIP_&#x0d;&#x0a;tentacle_port=_tentaclePort_&#x0d;&#x0a;tentacle_opts=_tentacleExtraOpt_&#x0d;&#x0a;advance_monitoring=_googleCEInstanceSummary_&#x0d;&#x0a;cpu_summary=_googleCECpuPerfSummary_&#x0d;&#x0a;iops_summary=_googleCEIopsPerfSummary_&#x0d;&#x0a;disk_summary=_googleCEDiskPerfSummary_&#x0d;&#x0a;network_summary=_googleCENetworkPerfSummary_&#x0d;&#x0a;creds_b64=_credentials_&#x0d;&#x0a;gcp_zones=_googleCEZones_&#x0d;&#x0a;gcp_instances=_googleCEInstances_&#x0d;&#x0a;stats_agent=_statsAgent_&#x0d;&#x0a;stats_agent_name=_statsAgentName_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Delete NULL macros
DELETE FROM `tdiscovery_apps_tasks_macros` WHERE `macro` = '';

-- Migrate current Google tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;
-- END MIGRATION GCP --

-- START MIGRATION SAP DESET --
-- Insert new SAP APP
SET @current_app_type = 10;
SET @short_name = 'pandorafms.sap.deset';
SET @name = 'SAP&#x20;R3&#x20;-&#x20;Deset';
SET @section = 'app';
SET @description = 'Monitor&#x20;SAP&#x20;R3&#x20;environments';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_sap_deset');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_java_', 'bin/lib/jre/bin/java');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--custom_modules&#x20;&#039;_tempfileCustomModules_&#039;');

-- Migrate current SAP tasks configurations
INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_server_', 'custom', `subnet`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sapClient_', 'custom', `field3`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sapSystem_', 'custom', `field2`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_sapLicense_', 'custom', `field4`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_credentials_', 'credentials.sap', `auth_strings`, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_threads_', 'custom', 1, 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_customModules_', 'custom', '[]', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_targetAgent_', 'custom', '', 0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`,
    '_customModulesDefinition_',
    'custom',
    JSON_UNQUOTE(
      JSON_EXTRACT(
        REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            REPLACE(
            CONVERT(FROM_BASE64(`field1`) USING UTF8MB4),
            '"160"',
            '""'
            ),
            '"109"',
            '""'
            ),
            '"111"',
            '""'
            ),
            '"113"',
            '""'
            ),
            '"121"',
            '""'
            ),
            '"104"',
            '""'
            ),
            '"105"',
            '""'
            ),
            '"150"',
            '""'
            ),
            '"151"',
            '""'
            ),
            '"102"',
            '""'
            ),
            '"103"',
            '""'
            ),
            '"192"',
            '""'
            ),
            '"195"',
            '""'
            ),
            '"116"',
            '""'
            ),
            '","',
            ""
        ),
        '$[0]'
      )
    ),
    0
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

SET @position = -1;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -2;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -3;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -4;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -5;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -6;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -7;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -8;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -9;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -10;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -11;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -12;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -13;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

SET @position = -14;
UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task` AS `main_trecon_task`
    SET `tdiscovery_apps_tasks_macros`.`value` = JSON_MERGE(
        `value`,
        (
            SELECT
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '160',
                    '"160"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '109',
                    '"109"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '111',
                    '"111"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '113',
                    '"113"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '121',
                    '"121"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '104',
                    '"104"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '105',
                    '"105"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '150',
                    '"150"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '151',
                    '"151"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '102',
                    '"102"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '103',
                    '"103"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '192',
                    '"192"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '195',
                    '"195"',
                IF(
                    SUBSTRING_INDEX(SUBSTRING_INDEX(REPLACE(SUBSTRING(SUBSTRING(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4), 1, LENGTH(CONVERT(FROM_BASE64(`trecon_task`.`field1`) USING UTF8MB4))-2), 3), '","', "\n"), "\n", @position), "\n", 1) = '116',
                    '"116"',
                    '""'
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
                )
            FROM `trecon_task`
            WHERE
                `trecon_task`.`type` = @current_app_type AND
                `trecon_task`.`id_rt` = `main_trecon_task`.`id_rt`
        )
    )
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `main_trecon_task`.`id_rt` AND
    `main_trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task`
    SET
    `tdiscovery_apps_tasks_macros`.`value` = REPLACE(REPLACE(REPLACE(`value`, '"", ', ''), '""', ''), ', ]', ']')
    WHERE 
    `tdiscovery_apps_tasks_macros`.`id_task` = `trecon_task`.`id_rt` AND
    `trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_customModules_'
;

UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task`
    SET
    `tdiscovery_apps_tasks_macros`.`value` = (
        SELECT `tconfig`.`value` FROM `tconfig` WHERE `tconfig`.`token` = 'sap_license'
    )
    WHERE
    `tdiscovery_apps_tasks_macros`.`id_task` = `trecon_task`.`id_rt` AND
    `trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_sapLicense_' AND
    `tdiscovery_apps_tasks_macros`.`value` = ''
;

UPDATE `tdiscovery_apps_tasks_macros`, `trecon_task`
    SET
    `tdiscovery_apps_tasks_macros`.`value` = 'trial'
    WHERE
    `tdiscovery_apps_tasks_macros`.`id_task` = `trecon_task`.`id_rt` AND
    `trecon_task`.`type` = @current_app_type AND
    `tdiscovery_apps_tasks_macros`.`macro` = '_sapLicense_' AND
    `tdiscovery_apps_tasks_macros`.`value` = ''
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileConf_', 'custom', 'agents_group_id&#x20;=&#x20;__taskGroupID__&#x0d;&#x0a;threads&#x20;=&#x20;_threads_&#x0d;&#x0a;interval&#x20;=&#x20;__taskInterval__&#x0d;&#x0a;server&#x20;=&#x20;_server_&#x0d;&#x0a;client&#x20;=&#x20;_sapClient_&#x0d;&#x0a;system&#x20;=&#x20;_sapSystem_&#x0d;&#x0a;license&#x20;=&#x20;_sapLicense_&#x0d;&#x0a;credentials&#x20;=&#x20;_credentials_&#x0d;&#x0a;agent&#x20;=&#x20;_targetAgent_&#x0d;&#x0a;modules&#x20;=&#x20;_customModules_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

INSERT IGNORE INTO `tdiscovery_apps_tasks_macros`
    (`id_task`, `macro`, `type`, `value`, `temp_conf`)
    SELECT
    `id_rt`, '_tempfileCustomModules_', 'custom', '_customModulesDefinition_', 1
    FROM `trecon_task`
    WHERE `type` = @current_app_type
;

-- Migrate current SAP tasks
UPDATE `trecon_task`
    SET
        `id_app` = @id_app,
        `setup_complete` = 1,
        `type` = 15
    WHERE `type` = @current_app_type
;

-- END MIGRATION SAP DESET --


UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/03_monitoring/06_web_monitoring' WHERE title = '¿Sab&iacute;as&#x20;que&#x20;puedes&#x20;monitorizar&#x20;webs?';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/03_monitoring/03_remote_monitoring#monitorizacion_snmp' WHERE title = 'Monitorizaci&oacute;n&#x20;remota&#x20;de&#x20;dispositivos&#x20;SNMP';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/03_monitoring/03_remote_monitoring#monitorizacion_de_rutas' WHERE title = 'Monitorizar&#x20;rutas&#x20;desde&#x20;una&#x20;IP&#x20;a&#x20;otra';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/04_using/11_managing_and_administration#paradas_de_servicio_planificadas' WHERE title = 'Paradas&#x20;planificadas';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/pandorafms/management_and_operation/01_alerts#configuracion_de_correos_para_alertas_en_pandora_fms' WHERE title = 'Personalizar&#x20;los&#x20;emails&#x20;de&#x20;alerta&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/start?id=es/documentation/04_using/05_data_presentation_visual_maps' WHERE title = 'Usando&#x20;iconos&#x20;personalizados&#x20;en&#x20;consolas&#x20;visuales&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/04_using/05_data_presentation_visual_maps#mapa_de_calor_o_nube_de_color' WHERE title = 'Consolas&#x20;visuales:&#x20;mapas&#x20;de&#x20;calor&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/04_using/11_managing_and_administration#log_de_auditoria' WHERE title = 'Auditor&iacute;a&#x20;interna&#x20;de&#x20;la&#x20;consola&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/start?id=es/documentation/02_installation/05_configuration_agents#configuracion_automatica_de_agentes' WHERE title = 'Sistema&#x20;de&#x20;provisi&oacute;n&#x20;autom&aacute;tica&#x20;de&#x20;agentes&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/04_using/05_data_presentation_visual_maps#enlace_de_red' WHERE title = 'Enlaces&#x20;de&#x20;red&#x20;en&#x20;la&#x20;consola&#x20;visual&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/04_using/08_data_presentation_reports#grafico_de_disponibilidad' WHERE title = 'Gr&aacute;ficas&#x20;de&#x20;disponibilidad&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/es/documentation/04_using/12_console_setup?s%5B%5D%3Dcontrase%25C3%25B1as#password_policy' WHERE title = 'Pol&iacute;tica&#x20;de&#x20;contrase&ntilde;as';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/12_console_setup?s%5B%5D%3Dgoogle%26s%5B%5D%3Dauth#authentication' WHERE title = 'Autenticaci&oacute;n&#x20;de&#x20;doble&#x20;factor&#x20;';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/03_monitoring/06_web_monitoring' WHERE title = 'Did&#x20;you&#x20;know&#x20;that&#x20;you&#x20;can&#x20;monitor&#x20;websites?';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/11_managing_and_administration#log_de_auditoria' WHERE title = 'Console&#x20;Internal&#x20;Audit';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/12_console_setup?s%5B%5D%3Dgoogle%26s%5B%5D%' WHERE title = 'Two-factor&#x20;authentication';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/05_data_presentation_visual_maps#mapa_de_cal' WHERE title = 'Visual&#x20;consoles:&#x20;heat&#x20;maps';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/05_data_presentation_visual_maps#enlace_de_red' WHERE title = 'Network&#x20;links&#x20;in&#x20;the&#x20;visual&#x20;console';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/08_data_presentation_reports#grafico_de_disp' WHERE title = 'Availability&#x20;graphs';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/03_monitoring/03_remote_monitoring#monitorizacion_snmp' WHERE title = 'Remote&#x20;monitoring&#x20;of&#x20;SNMP&#x20;devices';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/03_monitoring/03_remote_monitoring#monitorizacion_de_rutas' WHERE title = 'Monitor&#x20;routes&#x20;from&#x20;one&#x20;IP&#x20;to&#x20;another';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/11_managing_and_administration#scheduled_downtimes' WHERE title = 'Scheduled&#x20;downtimes';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/01_alerts#editing_an_action' WHERE title = 'Customize&#x20;alert&#x20;emails';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/en/documentation/04_using/12_console_setup?s%5B%5D%3Dcontrase%25C3%25B' WHERE title = 'password&#x20;policy';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/start?id=en/documentation/02_installation/05_configuration_agents#conf' WHERE title = 'Automatic&#x20;agent&#x20;provision&#x20;system';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/start?id=en/documentation/02_installation/05_configuration_agents#conf' WHERE title = 'Automatic&#x20;agent&#x20;provision&#x20;system';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/start?id=en/documentation/02_installation/05_configuration_agents#conf' WHERE title = 'Automatic&#x20;agent&#x20;provision&#x20;system';
UPDATE `twelcome_tip` SET url = 'https://pandorafms.com/manual/!current/start?id=en/documentation/04_using/05_data_presentation_visual_maps' WHERE title = 'Using&#x20;custom&#x20;icons&#x20;in&#x20;visual&#x20;consoles';

DELETE FROM tconfig WHERE `token` = 'legacy_database_ha';

UPDATE tncm_script SET `content` = 'sleep:1&#x0d;&#x0a;capture:export&#92;n&#92;r&#x20;&#x0d;&#x0a;exit&#92;n&#92;r' where `content` = 'sleep:1&#x0d;&#x0a;capture:system&#x20;resource&#x20;print&#92;n&#92;r&#x20;&#x0d;&#x0a;exit&#92;n&#92;r';

-- Add new columns in tdeployment_hosts
ALTER TABLE `tdeployment_hosts` ADD COLUMN `deploy_method` ENUM('SSH', 'HTTP', 'HTTPS') DEFAULT 'SSH';
ALTER TABLE `tdeployment_hosts` ADD COLUMN `deploy_port` INT UNSIGNED NOT NULL DEFAULT 22;
ALTER TABLE `tdeployment_hosts` ADD COLUMN `server_port` INT UNSIGNED NOT NULL DEFAULT 41121;
ALTER TABLE `tdeployment_hosts` ADD COLUMN `temp_folder` VARCHAR(500) DEFAULT '/tmp';

UPDATE
    `tdeployment_hosts`, `tconfig_os`
SET
    `tdeployment_hosts`.`deploy_method` = 'HTTP',
    `tdeployment_hosts`.`deploy_port` = 5985,
    `tdeployment_hosts`.`temp_folder` = 'C:&#92;Windows&#92;Temp'
WHERE
    `tdeployment_hosts`.`id_os` = `tconfig_os`.`id_os` AND `tconfig_os`.`name` = 'Windows' AND `tdeployment_hosts`.`deployed` = 0;

-- Find the name of the foreign key constraint
SELECT @constraint_name := `constraint_name`
FROM `information_schema`.`key_column_usage`
WHERE `table_name` = 'tdeployment_hosts' AND `column_name` = 'id_os';

-- Drop the foreign key constraint using dynamic SQL
SET @drop_fk_query = CONCAT('ALTER TABLE `tdeployment_hosts` DROP FOREIGN KEY ', @constraint_name);
PREPARE stmt FROM @drop_fk_query;
EXECUTE stmt;
DEALLOCATE PREPARE stmt;

-- Drop unused columns in tdeployment_hosts
ALTER TABLE `tdeployment_hosts` DROP COLUMN `id_os`;
ALTER TABLE `tdeployment_hosts` DROP COLUMN `os_version`;
ALTER TABLE `tdeployment_hosts` DROP COLUMN `arch`;

-- Update all deployment recon tasks port
UPDATE `trecon_task` SET `field4` = 41121 WHERE `type` = 9;

-- Update execution in proxmox discovery plugin
SET @short_name = 'pandorafms.proxmox';
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;
UPDATE `tdiscovery_apps_executions` SET `execution` = '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileProxmox_&#039;' WHERE `id_app` = @id_app;

INSERT INTO `tconfig` (`token`, `value`) VALUES ('JWT_signature', 1);
DELETE FROM tconfig WHERE `token` = 'loginhash_pwd';

UPDATE `tdiscovery_apps` SET `version` = '1.5' WHERE `short_name` = 'pandorafms.vmware';

-- Delete Create incident from event, from tevent_response
DELETE FROM tevent_response	WHERE name = 'Create&#x20;incident&#x20;from&#x20;event';

UPDATE tconfig_os SET `name` = 'Web&#x20;Server' WHERE `id_os` = 12;
UPDATE `tncm_script` SET `content` ='set&#x20;cli&#x20;pager&#x20;off&#x20;&#92;n&#x0d;&#x0a;capture:show&#x20;system&#x20;info&#x20;|&#x20;match&#x20;app-version:&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;exit&#x20;&#92;n'
WHERE `content`='set&#x20;cli&#x20;pager&#x20;off&#x20;&#92;n&#x0d;&#x0a;capture:show&#x20;system&#x20;info&#x20;|&#x20;match&#x20;app-version:&#92;n&#x0d;&#x0a;sleep:1&#x20;&#x0d;&#x0a;expect:app-version:&#92;s*&#x0d;&#x0a;exit&#x20;&#92;n';

UPDATE `tncm_script` SET `content` ='expect:root@%&#x0d;&#x0a;cli&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;capture:show&#x20;version|match&#x20;Junos:&#92;n&#x0d;&#x0a;quit&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;n'
WHERE `content`= 'expect:root@%&#x0d;&#x0a;cli&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;capture:show&#x20;version|match&#x20;Junos:&#92;n&#x0d;&#x0a;capture:&#x20;&#92;n&#x0d;&#x0a;quit&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;n';

UPDATE `tncm_script` SET `content` ='expect:root@%&#x0d;&#x0a;cli&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;capture:show&#x20;version|match&#x20;Junos:&#92;n&#x0d;&#x0a;quit&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;n'
WHERE `content`='expect:root@%&#x0d;&#x0a;cli&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;capture:show&#x20;version|match&#x20;Junos:&#92;n&#x0d;&#x0a;capture:&#x20;&#92;n&#x0d;&#x0a;quit&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;n';

SET @id_token_welcome_state = NULL;
SET @token_name_welcome_state = 'welcome_state';
SELECT @id_token_welcome_state := `id_config` FROM `tconfig` WHERE `token` = @token_name_welcome_state ORDER BY `id_config` DESC LIMIT 1;
DELETE FROM `tconfig` WHERE `token` = @token_name_welcome_state AND `id_config` != @id_token_welcome_state;

-- Add new vendor and model
SET @vendor_name = 'Cisco';
SET @model_name = 'Cisco-Generic';
SET @template_name = 'Cisco-Generic-Telnet';
SET @agent_data_template_name = 'Cisco-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;term&#x20;length&#x20;0&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;running-config&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_config = 'sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;term&#x20;length&#x20;0&#92;r&#92;n&#x0d;&#x0a;config&#x20;terminal&#92;r&#92;n&#x0d;&#x0a;_applyconfigbackup_&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;term&#x20;length&#x20;0&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;version&#x20;|&#x20;i&#x20;IOS&#x20;Software&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_firmware = 'sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;copy&#x20;tftp&#x20;flash&#92;r&#92;n&#x0d;&#x0a;expect:&#92;]&#92;?&#x0d;&#x0a;_TFTP_SERVER_IP_&#92;r&#92;n&#x0d;&#x0a;expect:&#92;]&#92;?&#x0d;&#x0a;_SOURCE_FILE_NAME_&#92;r&#92;n&#x0d;&#x0a;expect:&#92;]&#92;?&#x0d;&#x0a;firmware.bin&#92;r&#92;n&#x0d;&#x0a;show&#x20;flash&#92;r&#92;n&#x0d;&#x0a;reload&#92;r&#92;n&#x0d;&#x0a;expect:confirm&#x0d;&#x0a;y&#92;r&#92;n&#x0d;&#x0a;config&#x20;terminal&#92;r&#92;n&#x0d;&#x0a;boot&#x20;system&#x20;firmware.bin&#92;r&#92;n';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

-- Add new vendor and model
SET @vendor_name = 'Juniper';
SET @model_name = 'Juniper-Generic';
SET @template_name = 'Juniper-Generic-Telnet';
SET @agent_data_template_name = 'Juniper-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;&#92;r&#92;n&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;cli&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;&#92;r&#92;n&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;cli&#92;r&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;capture:show&#x20;configuration&#x20;|&#x20;no-more&#92;r&#92;n&#x0d;&#x0a;quit&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_config = 'sleep:1&#x0d;&#x0a;&#92;r&#92;n&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;cli&#92;r&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;configure&#92;r&#92;n&#x0d;&#x0a;load&#x20;override&#x20;terminal&#92;r&#92;n&#x0d;&#x0a;_applyconfigbackup_&#92;r&#92;n&#x0d;&#x0a;commit&#92;r&#92;n&#x0d;&#x0a;quit&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;&#92;r&#92;n&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;cli&#92;r&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;capture:show&#x20;version|match&#x20;Junos:&#92;r&#92;n&#x0d;&#x0a;quit&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_firmware = 'sleep:1&#x0d;&#x0a;&#92;r&#92;n&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;cli&#92;r&#92;n&#x0d;&#x0a;expect:root&gt;&#x0d;&#x0a;save&#x20;software&#x20;from&#x20;tftp&#x20;_TFTP_SERVER_IP_&#x20;_FIRMWARE_NAME_&#x20;to&#x20;flash&#92;r&#92;n&#x0d;&#x0a;reset&#92;r&#92;n&#x0d;&#x0a;quit&#92;r&#92;n&#x0d;&#x0a;expect:root@%&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

-- Add new vendor and model
SET @vendor_name = 'Palo&#x20;Alto';
SET @model_name = 'Palo&#x20;Alto-Generic';
SET @template_name = 'Palo&#x20;Alto-Generic-Telnet';
SET @agent_data_template_name = 'Palo&#x20;Alto-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;set&#x20;cli&#x20;pager&#x20;off&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;config&#x20;running&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_config = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;set&#x20;cli&#x20;terminal&#x20;width&#x20;500&#92;r&#92;n&#x0d;&#x0a;set&#x20;cli&#x20;scripting-mode&#x20;on&#92;r&#92;n&#x0d;&#x0a;configure&#92;r&#92;n&#x0d;&#x0a;_applyconfigbackup_&#92;r&#92;n&#x0d;&#x0a;commit&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;set&#x20;cli&#x20;pager&#x20;off&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;system&#x20;info&#x20;|&#x20;match&#x20;app-version:&#92;r&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_firmware = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;tftp&#x20;import&#x20;software&#x20;from&#x20;_TFTP_SERVER_IP_&#x20;file&#x20;_FIRMWARE_NAME_&#92;r&#92;n&#x0d;&#x0a;request&#x20;system&#x20;software&#x20;install&#x20;version&#92;r&#92;n&#x0d;&#x0a;reboot&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

-- Add new vendor and model
SET @vendor_name = 'A10';
SET @model_name = 'A10-Generic';
SET @template_name = 'A10-Generic-Telnet';
SET @agent_data_template_name = 'A10-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;running-config&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;expect:Are&#x20;you&#x20;sure&#x20;to&#x20;quit&#x20;&#40;N/Y&#41;?:&#92;s*&#x0d;&#x0a;y&#92;r&#92;n';
SET @script_set_config = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;configure&#92;r&#92;n&#x0d;&#x0a;_applyconfigbackup_&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;expect:Are&#x20;you&#x20;sure&#x20;to&#x20;quit&#x20;&#40;N/Y&#41;?:&#92;s*&#x0d;&#x0a;y&#92;r&#92;n';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;version&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;expect:Are&#x20;you&#x20;sure&#x20;to&#x20;quit&#x20;&#40;N/Y&#41;?:&#92;s*&#x0d;&#x0a;y&#92;r&#92;n';
SET @script_set_firmware = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;configure&#92;r&#92;n&#x0d;&#x0a;expect:&#40;config&#41;&#x0d;&#x0a;restore&#x20;_TFTP_SERVER_IP_/_FIRMWARE_NAME_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;expect:skip&#x20;port&#x20;map&#x0d;&#x0a;yes&#92;r&#92;n&#x0d;&#x0a;expect:&#x20;see&#x20;the&#x20;diff&#x0d;&#x0a;yes&#92;r&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;expect:Proceed&#x20;with&#x20;reboot&#x0d;&#x0a;yes&#92;r&#92;n&#x0d;&#x0a;expect:eof';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

-- Add new vendor and model
SET @vendor_name = 'Alcatel-Lucent Enterprise';
SET @model_name = 'Alcatel-Generic';
SET @template_name = 'Alcatel-Generic-Telnet';
SET @agent_data_template_name = 'Alcatel-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;&#92;n&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;&#92;n&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;enable&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;environment&#x20;no&#x20;more&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;capture:admin&#x20;display-config&#92;n&#x0d;&#x0a;sleep:3&#x0d;&#x0a;logout&#92;n';
SET @script_set_config = '';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;&#92;n&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;enable&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;capture:show&#x20;version&#92;n&#x0d;&#x0a;sleep:3&#x0d;&#x0a;logout&#92;n';
SET @script_set_firmware = '';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

-- Add new vendor and model
SET @vendor_name = 'Aruba';
SET @model_name = 'Aruba-Generic';
SET @template_name = 'Aruba-Generic-Telnet';
SET @agent_data_template_name = 'Aruba-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;running-config&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n&#x0d;&#x0a;expect:Are&#x20;you&#x20;sure&#x20;to&#x20;quit&#x20;&#40;N/Y&#41;?:&#92;s*&#x0d;&#x0a;y&#92;r&#92;n';
SET @script_set_config = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;configure&#x20;terminal&#92;r&#92;n&#x0d;&#x0a;load&#x20;replace&#x20;/var/tmp/file.conf&#92;r&#92;n&#x0d;&#x0a;end&#92;r&#92;n&#x0d;&#x0a;write&#x20;memory&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;enable&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;capture:show&#x20;version&#92;r&#92;n&#x0d;&#x0a;exit&#92;r&#92;n';
SET @script_set_firmware = 'sleep:1&#x0d;&#x0a;expect:login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;copy&#x20;tftp&#x20;flash&#x20;_TFTP_SERVER_IP_&#x20;firmware.bin.swi&#x20;secondary&#92;r&#92;n&#x0d;&#x0a;boot&#x20;system&#x20;flash&#x20;secondary&#92;r&#92;n&#x0d;&#x0a;copy&#x20;tftp&#x20;flash&#x20;&#x20;_TFTP_SERVER_IP_&#x20;firmware.bin&#x20;primary&#92;r&#92;n&#x0d;&#x0a;boot&#x20;system&#x20;flash&#x20;primary&#92;r&#92;n';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

-- Add new vendor and model
SET @vendor_name = 'Mikrotik';
SET @model_name = 'Mikrotik-Generic';
SET @template_name = 'Mikrotik-Generic-Telnet';
SET @agent_data_template_name = 'Mikrotik-Generic-Telnet';
SET @script_test = 'sleep:1&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;sleep:1&#x0d;&#x0a;exit&#92;r&#92;n&#92;r';
SET @script_get_config = 'sleep:1&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;capture:system&#x20;resource&#x20;print&#92;r&#92;n&#92;r&#x20;&#x0d;&#x0a;exit&#92;r&#92;n&#92;r';
SET @script_set_config = 'sleep:1&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;system&#x20;backup&#x20;load&#x20;name=_nameBackup_&#x20;password=_passwordBackup_&#92;n&#92;r&#x0d;&#x0a;expect:Restore&#x0d;&#x0a;yes&#92;n&#92;r&#x0d;&#x0a;quit&#92;n&#92;r';
SET @script_get_firmware = 'sleep:1&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;capture:/system&#x20;package&#x20;print&#92;n&#92;r&#x20;&#x0d;&#x0a;quit&#92;n&#92;r';
SET @script_set_firmware = 'sleep:1&#x0d;&#x0a;expect:Login:&#92;s*&#x0d;&#x0a;_username_&#92;r&#92;n&#x0d;&#x0a;expect:Password:&#92;s*&#x0d;&#x0a;_enablepass_&#92;r&#92;n&#x0d;&#x0a;/system&#x20;routerboard&#x20;upgrade&#92;n&#92;r&#x0d;&#x0a;expect:Do&#x0d;&#x0a;yes&#92;n&#92;r&#x0d;&#x0a;quit&#92;n&#92;r';
SET @script_custom = '';
SET @script_os_version = @script_get_firmware;

-- Try to insert vendor
INSERT IGNORE INTO `tncm_vendor` (`id`, `name`, `icon`) VALUES ('', @vendor_name, '');
-- Get vendor ID
SELECT @id_vendor := `id` FROM `tncm_vendor` WHERE `name` = @vendor_name;

-- Try to insert model
INSERT IGNORE INTO `tncm_model` (`id`, `id_vendor`, `name`) VALUES ('', @id_vendor, @model_name);
-- Get model ID
SELECT @id_model := `id` FROM `tncm_model` WHERE `id_vendor` = @id_vendor AND `name` = @model_name;

-- Get template ID if exists
SET @id_template = NULL;
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;
-- Try to insert template
INSERT IGNORE INTO `tncm_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_template, @template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get template ID again if inserted
SELECT @id_template := `id` FROM `tncm_template` WHERE `name` = @template_name;

-- Get agent data template ID if exists
SET @id_agent_data_template = NULL;
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;
-- Try to insert agent data template
INSERT IGNORE INTO `tncm_agent_data_template` (`id`, `name`, `vendors`, `models`) VALUES (@id_agent_data_template, @agent_data_template_name, CONCAT('[',@id_vendor,']'), CONCAT('[',@id_model,']'));
-- Get agent data template ID again if inserted
SELECT @id_agent_data_template := `id` FROM `tncm_agent_data_template` WHERE `name` = @agent_data_template_name;

-- Get test script ID if exists
SET @id_script_test = NULL;
SET @script_type = 0;
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;
-- Try to insert test script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_test, @script_type, @script_test);
-- Get test script ID again if inserted
SELECT @id_script_test := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_test;

-- Get get_config script ID if exists
SET @id_script_get_config = NULL;
SET @script_type = 1;
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;
-- Try to insert get_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_config, @script_type, @script_get_config);
-- Get get_config script ID again if inserted
SELECT @id_script_get_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_config;

-- Get set_config script ID if exists
SET @id_script_set_config = NULL;
SET @script_type = 2;
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;
-- Try to insert set_config script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_config, @script_type, @script_set_config);
-- Get set_config script ID again if inserted
SELECT @id_script_set_config := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_config;

-- Get get_firmware script ID if exists
SET @id_script_get_firmware = NULL;
SET @script_type = 3;
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;
-- Try to insert get_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_get_firmware, @script_type, @script_get_firmware);
-- Get get_firmware script ID again if inserted
SELECT @id_script_get_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_get_firmware;

-- Get set_firmware script ID if exists
SET @id_script_set_firmware = NULL;
SET @script_type = 4;
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;
-- Try to insert set_firmware script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_set_firmware, @script_type, @script_set_firmware);
-- Get set_firmware script ID again if inserted
SELECT @id_script_set_firmware := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_set_firmware;

-- Get custom script ID if exists
SET @id_script_custom = NULL;
SET @script_type = 5;
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;
-- Try to insert custom script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_custom, @script_type, @script_custom);
-- Get custom script ID again if inserted
SELECT @id_script_custom := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_custom;

-- Get os_version script ID if exists
SET @id_script_os_version = NULL;
SET @script_type = 7;
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;
-- Try to insert os_version script
INSERT IGNORE INTO `tncm_script` (`id`, `type`, `content`) VALUES (@id_script_os_version, @script_type, @script_os_version);
-- Get os_version script ID again if inserted
SELECT @id_script_os_version := `id` FROM `tncm_script` WHERE `type` = @script_type AND `content` = @script_os_version;

-- Get template scripts ID if exists
SET @id_ts_test = NULL;
SELECT @id_ts_test := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_test;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_test, @id_template, @id_script_test);

-- Get template scripts ID if exists
SET @id_ts_get_config = NULL;
SELECT @id_ts_get_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_config, @id_template, @id_script_get_config);

-- Get template scripts ID if exists
SET @id_ts_set_config = NULL;
SELECT @id_ts_set_config := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_config;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_config, @id_template, @id_script_set_config);

-- Get template scripts ID if exists
SET @id_ts_get_firmware = NULL;
SELECT @id_ts_get_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_get_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_get_firmware, @id_template, @id_script_get_firmware);

-- Get template scripts ID if exists
SET @id_ts_set_firmware = NULL;
SELECT @id_ts_set_firmware := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_set_firmware;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_set_firmware, @id_template, @id_script_set_firmware);

-- Get template scripts ID if exists
SET @id_ts_custom = NULL;
SELECT @id_ts_custom := `id` FROM `tncm_template_scripts` WHERE `id_template` = @id_template AND `id_script` = @id_script_custom;
-- Try to insert
INSERT IGNORE INTO `tncm_template_scripts` (`id`, `id_template`, `id_script`) VALUES (@id_ts_custom, @id_template, @id_script_custom);

-- Get template scripts ID if exists
SET @id_ts_os_version = NULL;
SELECT @id_ts_os_version := `id` FROM `tncm_agent_data_template_scripts` WHERE `id_agent_data_template` = @id_template AND `id_script` = @id_script_os_version;
-- Try to insert
INSERT IGNORE INTO `tncm_agent_data_template_scripts` (`id`, `id_agent_data_template`, `id_script`) VALUES (@id_ts_os_version, @id_agent_data_template, @id_script_os_version);

COMMIT;